package com.njcn.csharmonic.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csharmonic.api.PqGovernPlanFeignClient;
import com.njcn.csharmonic.pojo.po.PqGovernPlan;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author xy
 */
@Slf4j
@Component
public class PqGovernPlanClientFallbackFactory implements FallbackFactory<PqGovernPlanFeignClient> {
    @Override
    public PqGovernPlanFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new PqGovernPlanFeignClient() {
            @Override
            public HttpResult<List<PqGovernPlan>> getListExcludeNull() {
                log.error("{}异常，降级处理，异常为：{}","查询所有治理方案异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<List<PqGovernPlan>> getListByMonitorPoint(List<String> ids) {
                log.error("{}异常，降级处理，异常为：{}","清空治理前后监测点数据异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<PqGovernPlan> getById(String id) {
                log.error("{}异常，降级处理，异常为：{}","根据ID查询治理方案异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
